var SendToMI = new function () 
{
	var EXTENSION_GUID = "{9208b9ae-7f13-4aed-98b0-d7dac127f253}";
	var TEMP_DIR = "sendtomyinfo";
	var CONTENT_FILE_NAME = "mitransfercontent";
	var TITLE_FILE_NAME = "mitransfertitle";
	var URL_FILE_NAME = "mitransferurl";

	var sendAttachment;

	this.SendAttachment = function()
	{
		sendAttachment = true;
		sendToApplication();
	};

	this.Send = function()
	{
		sendAttachment = false;
		sendToApplication();
	};

	function sendToApplication()
	{
		try
		{
			Components.utils.import("resource://gre/modules/AddonManager.jsm");

			AddonManager.getAddonByID(EXTENSION_GUID, function(addon)
			{
				var file = addon.getResourceURI('components/SendApp.exe').QueryInterface(Components.interfaces.nsIFileURL).file;
				sendToApplicationInternal(file.path);
			});
		} 
		
		catch(e)
		{
			alert("exception:" + e);
		}
		
		return true; // handled
	}

	function sendToApplicationInternal(fileName)
	{
		var sendAppFile = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		sendAppFile.initWithPath(fileName);
			
		var sendAppProcess = Components.classes["@mozilla.org/process/util;1"]
			.createInstance(Components.interfaces.nsIProcess);
		sendAppProcess.init(sendAppFile);
		
		collectTransferData();
		
		var attachmentString = sendAttachment ? "1" : "0";
		var args = [getContentFileName(), getTitleFileName(), getUrlFileName(), attachmentString];
		sendAppProcess.run(false, args, args.length);
	}

  function getHtmlSelection()
  {
    var html = '';

    var focusedWindow = document.commandDispatcher.focusedWindow;
    var selection = focusedWindow.getSelection();

    if(selection && selection.rangeCount)
    {
      var container = this.content.document.createElement("div");
      for(var i = 0, len = selection.rangeCount; i < len; ++i)
      {
        container.appendChild(selection.getRangeAt(i).cloneContents());
      }

      html = container.innerHTML;
    }

    return html;
  }

	function collectTransferData()
	{
		// selection
		var html = getHtmlSelection();
    if(html && sendAttachment)
    {
      var head = '<head>'+this.content.document.getElementsByTagName('head')[0].innerHTML+'</head>';
      html = head+'<body>'+html+'</body>';
    }
		
		// content
		writeFile(html, getContentFileName());
		
		// title
		writeFile(window.content.document.title, getTitleFileName());
		
		// url
		writeFile(window.content.location.href, getUrlFileName());

		return true;
	}

	function getContentFileName()
	{
		return getTempDir() + CONTENT_FILE_NAME;
	}

	function getTitleFileName()
	{
		return getTempDir() + TITLE_FILE_NAME;
	}

	function getUrlFileName()
	{
		return getTempDir() + URL_FILE_NAME;
	}

	function fileExists(fileName)
	{
		var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(filename);
		
		return file.exists();
	}

	function getTempDir()
	{
		var folder = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("TmpD", Components.interfaces.nsIFile);
		
		folder.append(TEMP_DIR);
		if(!folder.exists() || !folder.isDirectory())
			folder.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
		
		return folder.path + '\\';
	}

	function writeFile(data, fileName)
	{
		// file is nsIFile, data is a string
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(fileName);
		if (file.exists())
			file.remove(true);
			
		file.create(file.NORMAL_FILE_TYPE, 0666);
		 
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
					createInstance(Components.interfaces.nsIFileOutputStream);
		
		foStream.init(file, -1, -1, false);

		var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
						createInstance(Components.interfaces.nsIConverterOutputStream);
		converter.init(foStream, "UTF-8", 0, 0);
		converter.writeString(data);
		converter.close();
		
		foStream.close();
	}
};